﻿using System;

namespace BlackJack_0_0_3
{
    class BlackJackTest
    {
        public static bool Card_OK()
        {
            Card card = new Card(Suit.SPADE, 1);
            return (card.suit == Suit.SPADE && card.rank == 1);
        }
        public static bool Deck_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 1),
                new Card(Suit.HEART, 11),
                new Card(Suit.DIAMOND, 10) 
					   };
            Deck deck = new Deck(cards);
            Card card;
            card = deck.DealACard();
            bool success1 = (card.suit == Suit.SPADE && card.rank == 1);
            card = deck.DealACard();
            bool success2 = (card.suit == Suit.HEART && card.rank == 11);
            card = deck.DealACard();
            bool success3 = (card.suit == Suit.DIAMOND && card.rank == 10);
            return success1 && success2 && success3;
        }
        public static bool Scenario_1_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 1),
                  new Card(Suit.HEART, 11),
                  new Card(Suit.DIAMOND, 10) };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer = new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            return (player.GetStatus()==Status.BLACK_JACK && computer.GetStatus()==Status.PASS);
        }
    }
}
