﻿/*
 * 21點測試
 * 3/6/2009
 */

using System;

namespace BlackJack_0_0_5
{
    class BlackJackTest
    {
        public static bool Card_OK()
        {
            Card card1 = new Card(Suit.SPADE, 1); ;
            return (card1.suit == Suit.SPADE &&
                 card1.rank == 1);
        }
        public static bool Deck_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 1),
                new Card(Suit.HEART, 11),
                new Card(Suit.DIAMOND, 10)
                           };
            Deck deck = new Deck(cards);
            Card card;
            card = deck.DealACard();
            bool card1_OK = (card.suit == Suit.SPADE
                && card.rank == 1);
            card = deck.DealACard();
            bool card2_OK = (card.suit == Suit.HEART
                && card.rank == 11);
            card = deck.DealACard();
            bool card3_OK = (
                card.suit == Suit.DIAMOND &&
                card.rank == 10);
            return (card1_OK && card2_OK && card3_OK);
        }
        public static bool DeckRandom_OK()
        {
            Deck deck = new Deck(123);
            Card[] cards = new Card[52];
            int i;
            for (i = 0; i < 52; ++i)
            {
                cards[i] = deck.DealACard();
            }
            int[] nSuit = new int[4];
            int s;
            for (s = 0; s < 4; ++s)
            {
                nSuit[s] = 0;
            }
            int[] nRank = new int[13];
            int r;
            for (r = 0; r < 13; ++r)
            {
                nRank[r] = 0;
            }
            for (i = 0; i < 52; ++i)
            {
                switch (cards[i].suit)
                {
                    case Suit.CLUB:
                        nSuit[0]++;
                        break;
                    case Suit.DIAMOND:
                        nSuit[1]++;
                        break;
                    case Suit.HEART:
                        nSuit[2]++;
                        break;
                    case Suit.SPADE:
                        nSuit[3]++;
                        break;
                    default:
                        break;
                }
                nRank[cards[i].rank - 1]++;
            }
            bool suit_OK = true;
            for (s = 0; s < 4; s++)
            {
                if (nSuit[s] != 13)
                {
                    suit_OK = false;
                    break;
                }
            }
            bool rank_OK = true;
            for (r = 0; r < 13; r++)
            {
                if (nRank[r] != 4)
                {
                    rank_OK = false;
                    break;
                }
            }
            return suit_OK && rank_OK;
        }
        public static bool Scenario_1_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 1),
                  new Card(Suit.HEART, 11),
                  new Card(Suit.DIAMOND, 10)
                           };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer =
                new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            return (player.GetStatus() ==
                    Status.BLACK_JACK &&
                       computer.GetStatus() ==
                    Status.PASS);
        }
        public static bool Scenario_2_OK()
        {
            Card[] cards = { 
				new Card(Suit.CLUB, 3),
                  new Card(Suit.HEART, 11),
                  new Card(Suit.SPADE, 10),
                  new Card(Suit.DIAMOND, 1)
                           };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer =
                new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            return (player.GetStatus() == Status.PASS
                    && computer.GetStatus() ==
                       Status.BLACK_JACK);
        }
        public static bool Scenario_3_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 8),
                  new Card(Suit.HEART, 11),
                  new Card(Suit.DIAMOND, 7),
                  new Card(Suit.SPADE, 2),
                  new Card(Suit.CLUB, 6)
                           };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer =
                new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            return (player.GetStatus() == Status.BLACK_JACK &&
                    computer.GetStatus() ==
                    Status.PASS);
        }
        public static bool Scenario_4_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 8),
                  new Card(Suit.HEART, 5),
                  new Card(Suit.DIAMOND, 8),
                  new Card(Suit.SPADE, 9),
                  new Card(Suit.CLUB, 6)
                           };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer =
                new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            return (player.GetStatus() ==
                Status.BURST &&
                    computer.GetStatus() ==
                Status.PASS);
        }
        public static bool Scenario_5_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 8),
                  new Card(Suit.HEART, 5),
                  new Card(Suit.DIAMOND, 8),
                  new Card(Suit.SPADE, 9),
                  new Card(Suit.CLUB, 6)
                           };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer =
                new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            return (player.GetTotalPoints() == 16 &&
                    computer.GetTotalPoints() == 20);
        }
        public static bool Scenario_6_OK()
        {
            Card[] cards = { 
				new Card(Suit.SPADE, 8),
                  new Card(Suit.HEART, 5),
                  new Card(Suit.DIAMOND, 8),
                  new Card(Suit.SPADE, 9),
                  new Card(Suit.CLUB, 8)
                           };
            Deck deck = new Deck(cards);
            HumanPlayer player = new HumanPlayer();
            ComputerPlayer computer =
                new ComputerPlayer();
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            player.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            computer.SaveACard(deck.DealACard());
            return (player.GetTotalPoints() == 16 &&
                    computer.GetTotalPoints() == 22
                 && computer.GetStatus() ==
                    Status.BURST);
        }
        public static bool Game_OK()
        {
            Console.WriteLine("Game 測試");
            Game game = new Game();
            game.Run(123);
            return true;
        }
    }
}
