﻿/*
 * 模擬擲骰子示範一維陣列的使用
 * 9/26/2008
 *
 * 測試規畫:
 * 六個點數出現次數應該大約相同 
 */

using System;

namespace DiceSimulation3
{
    class Program
    {
        static void Main(string[] args)
        {
            int[] count = new int[6]; // 累計點數出現次數
            for (int i = 0; i < 6; ++i)
            {
                count[i] = 0;
            }
            const int N = 12000; // 總擲骰次數
            int faceValue;
            int seed = 123;
            Dice dice = new Dice(seed);
            // 擲骰N次
            for (int i = 0; i < N; ++i)
            {
                dice.Toss();
                faceValue = dice.FaceValue;
                ++count[faceValue - 1];
            }
            // 印出結果
            for (int i = 0; i < 6; ++i)
            {
                Console.WriteLine(" {0} appears {1} times ",
                    i + 1, count[i]);
            }      
        }
    }
}
